version: 1

secrets:
  pg-credentials:
    string_data:
      username: authentik
      password: {{ derive_entropy(identifier="db_password") }}
  secret-key:
    string_data:
      key: {{ derive_entropy(identifier="secret_key") }}
  authentik-credentials:
    string_data:
      password: {{ derive_entropy(identifier="password") }}

containers:
  postgresql:
    image: postgres:15-alpine
    mounts:
      data:
        db/pg: /var/lib/postgresql/data
    environment:
      POSTGRES_PASSWORD:
        secret: pg-credentials
        key: password
      POSTGRES_USER:
        secret: pg-credentials
        key: username
      POSTGRES_DB: authentik
    internal_ports:
      5432: 5432
    network_policy:
      ingress:
        allow_same_ns: true
      egress:
        allow_same_ns: false
        allow_world: false
        dns:
          allow: false
  redis:
    image: redis:alpine
    command: --save 60 1 --loglevel warning
    mounts:
      data:
        redis/data: /data
    internal_ports:
      6379: 6379
    network_policy:
      ingress:
        allow_same_ns: true
      egress:
        allow_same_ns: false
        allow_world: false
        dns:
          allow: false
  main:
    image: ghcr.io/goauthentik/server:2024.2.2
    ingress_port: 9000
    command: server
    environment:
      AUTHENTIK_BOOTSTRAP_PASSWORD:
        secret: authentik-credentials
        key: password
      AUTHENTIK_REDIS__HOST: redis.authentik.{{user}}.nirvati
      AUTHENTIK_POSTGRESQL__HOST: postgresql.authentik.{{user}}.nirvati
      AUTHENTIK_POSTGRESQL__USER: authentik
      AUTHENTIK_POSTGRESQL__NAME:
        secret: pg-credentials
        key: username
      AUTHENTIK_POSTGRESQL__PASSWORD:
        secret: pg-credentials
        key: password
      AUTHENTIK_SECRET_KEY:
        secret: secret-key
        key: key
    mounts:
      data:
        media: /media
        certs: /certs
        templates: /templates
  worker:
    image: ghcr.io/goauthentik/server:2024.2.2
    command: worker
    environment:
      AUTHENTIK_REDIS__HOST: redis.authentik.{{user}}.nirvati
      AUTHENTIK_POSTGRESQL__HOST: postgresql.authentik.{{user}}.nirvati
      AUTHENTIK_POSTGRESQL__USER: authentik
      AUTHENTIK_POSTGRESQL__NAME:
        secret: pg-credentials
        key: username
      AUTHENTIK_POSTGRESQL__PASSWORD:
        secret: pg-credentials
        key: password
      AUTHENTIK_SECRET_KEY:
        secret: secret-key
        key: key
    service_account:
      rules:
      - apiGroups:
          - apiextensions.k8s.io
        resources:
          - customresourcedefinitions
        verbs:
          - list
    mounts:
      data:
        media: /media
        certs: /certs
        templates: /templates
